local screenW, screenH = guiGetScreenSize()
local x, y = (screenW/1360), (screenH/768)

function dxDrawRoundedRectangle(x, y, rx, ry, color, radius, postGUI)
    rx = rx - radius * 2
    ry = ry - radius * 2
    x = x + radius
    y = y + radius

    postGUI = true

    if (rx >= 0) and (ry >= 0) then
        dxDrawRectangle(x, y, rx, ry, color, postGUI)
        
        dxDrawRectangle(x, y - radius, rx, radius, color, postGUI)
        dxDrawRectangle(x, y + ry, rx, radius, color, postGUI)
        dxDrawRectangle(x - radius, y, radius, ry, color, postGUI)
        dxDrawRectangle(x + rx, y, radius, ry, color, postGUI)

        dxDrawCircle(x, y, radius, 180, 270, color, color, 7, _, postGUI)
        dxDrawCircle(x + rx, y, radius, 270, 360, color, color, 7, _, postGUI)
        dxDrawCircle(x + rx, y + ry, radius, 0, 90, color, color, 7, _, postGUI)
        dxDrawCircle(x, y + ry, radius, 90, 180, color, color, 7, _, postGUI)
    end
end

local infobox = {}
local font = dxCreateFont("files/font.ttf", 14)

addEventHandler("onClientRender", getRootElement(), function()
    for i, box in ipairs(infobox) do
        if i > 3 then
            table.remove(infobox, 1)
        end
        local textW = dxGetTextWidth( box.text, 0.75, font, false )
        if (getTickCount() - box.tick > 10000) then
            table.remove(infobox, 1)
        end
        local progress = ( getTickCount( ) - box.tick ) / 600 
		local animation = interpolateBetween( x*0 - textW, 0, 0, 0, 0, 0, progress, "OutQuad" )
        local alpha = interpolateBetween(255, 0, 0, 0, 0, 0, (getTickCount() - box.tick) / 1000 , "Linear")
        local barra = interpolateBetween(x*60 + textW, 0, 0, 0, 0, 0, (getTickCount() - box.tick) / 10000 , "Linear")

        dxDrawRoundedRectangle(animation + x*13, y*502 - i * 39, x*60 + textW, y*35, tocolor(box.color[1], box.color[2], box.color[3], box.alpha), 4)
        dxDrawRoundedRectangle(animation + x*13, y*502 - i * 39, barra, y*35, tocolor(box.barcolor[1], box.barcolor[2], box.barcolor[3], box.alpha), 4)
        dxDrawText(box.text, animation + x*25, y*511 - i * 39, x*64, y*525, tocolor(255, 255, 255, box.alpha), 0.75, font, "left", "top", false, false, true, false, false)
        dxDrawImage( animation + x*40 + textW, y*507 - i * 39, x*25, y*25, "files/"..box.type..".png", 0, 0, 0, tocolor( 255, 255, 255, box.alpha ), true )

        setTimer(function()
            box.alpha = alpha
        end, 9000, 1)       
    end
end)

function showInfobox(text, type)
    local settings = setmetatable({
        text = text,
		type = type,
		alpha = 255,
		visible = true,
		tick = getTickCount(),
		color = {}, 
        barcolor = {},
    }, infobox)

    if (settings) then
        if (settings.type == "success") then
            settings.color = {41, 198, 113}
            settings.barcolor = {33, 144, 84}
        elseif (settings.type == "error") then
            settings.color = {235, 60, 60}
            settings.barcolor = {175, 26, 26}
        elseif (settings.type == "info") then
            settings.color = {54, 207, 240}
            settings.barcolor = {34, 162, 190}
        elseif (settings.type == "warning") then
            settings.color = {240, 166, 54}
            settings.barcolor = {219, 143, 29}
        end
        table.insert(infobox, settings)
    end
    return settings;
end
addEvent("showInfobox", true)
addEventHandler("showInfobox", getRootElement(), showInfobox)
